Create items and bundles - Fabric

Create items and bundles

cURL

curl --request POST \
  --url https://live.copilot.fabric.inc/api-product/v1/product/bulk/insert \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-site-context: <x-site-context>' \
  --data '[\
  {\
    "sku": "sku_abc",\
    "type": "ITEM",\
    "nodeName": "PRIMARY->electronics",\
    "parentSku": "sku123",\
    "attributeValues": [\
      {\
        "name": "Mobile",\
        "value": "AMD X570 mobo"\
      }\
    ],\
    "inheritedAttributes": [\
      {\
        "name": "color",\
        "action": "SET"\
      }\
    ],\
    "bundleItems": [\
      {\
        "sku": "sku123",\
        "quantity": 6\
      }\
    ]\
  }\
]'

Python

import requests

url = "https://live.copilot.fabric.inc/api-product/v1/product/bulk/insert"

payload = [\
    {\
        "sku": "sku_abc",\
        "type": "ITEM",\
        "nodeName": "PRIMARY->electronics",\
        "parentSku": "sku123",\
        "attributeValues": [\
            {\
                "name": "Mobile",\
                "value": "AMD X570 mobo"\
            }\
        ],\
        "inheritedAttributes": [\
            {\
                "name": "color",\
                "action": "SET"\
            }\
        ],\
        "bundleItems": [\
            {\
                "sku": "sku123",\
                "quantity": 6\
            }\
        ]\
    }\
]
headers = {\
    "x-site-context": "<x-site-context>",\
    "Authorization": "Bearer <token>",\
    "Content-Type": "application/json"\
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript (Fetch)

const options = {\
  method: 'POST',\
  headers: {\
    'x-site-context': '<x-site-context>',\
    Authorization: 'Bearer <token>',\
    'Content-Type': 'application/json'\
  },\
  body: JSON.stringify([\
    {\
      sku: 'sku_abc',\
      type: 'ITEM',\
      nodeName: 'PRIMARY->electronics',\
      parentSku: 'sku123',\
      attributeValues: [{name: 'Mobile', value: 'AMD X570 mobo'}],\
      inheritedAttributes: [{name: 'color', action: 'SET'}],\
      bundleItems: [{sku: 'sku123', quantity: 6}]\
    }\
  ])\
};

fetch('https://live.copilot.fabric.inc/api-product/v1/product/bulk/insert', options)
  .then(res => res.json())\
  .then(res => console.log(res))\
  .catch(err => console.error(err));

PHP

<?php

$curl = curl_init();

curl_setopt_array($curl, [\
  CURLOPT_URL => "https://live.copilot.fabric.inc/api-product/v1/product/bulk/insert",\
  CURLOPT_RETURNTRANSFER => true,\
  CURLOPT_ENCODING => "",\
  CURLOPT_MAXREDIRS => 10,\
  CURLOPT_TIMEOUT => 30,\
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,\
  CURLOPT_CUSTOMREQUEST => "POST",\
  CURLOPT_POSTFIELDS => json_encode([\
    [\
        'sku' => 'sku_abc',\
        'type' => 'ITEM',\
        'nodeName' => 'PRIMARY->electronics',\
        'parentSku' => 'sku123',\
        'attributeValues' => [\
                [\
                                'name' => 'Mobile',\
                                'value' => 'AMD X570 mobo'\
                ]\
        ],\
        'inheritedAttributes' => [\
                [\
                                'name' => 'color',\
                                'action' => 'SET'\
                ]\
        ],\
        'bundleItems' => [\
                [\
                                'sku' => 'sku123',\
                                'quantity' => 6\
                ]\
        ]\
    ]\
  ]),\
  CURLOPT_HTTPHEADER => [\
    "Authorization: Bearer <token>",\
    "Content-Type: application/json",\
    "x-site-context: <x-site-context>"\
  ],\
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>

Go

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://live.copilot.fabric.inc/api-product/v1/product/bulk/insert"

payload := strings.NewReader("[\n  {\n    \"sku\": \"sku_abc\",\n    \"type\": \"ITEM\",\n    \"nodeName\": \"PRIMARY->electronics\",\n    \"parentSku\": \"sku123\",\n    \"attributeValues\": [\n      {\n        \"name\": \"Mobile\",\n        \"value\": \"AMD X570 mobo\"\n      }\n    ],\n    \"inheritedAttributes\": [\n      {\n        \"name\": \"color\",\n        \"action\": \"SET\"\n      }\n    ],\n    \"bundleItems\": [\n      {\n        \"sku\": \"sku123\",\n        \"quantity\": 6\n      }\n    ]\n  }\n]")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-site-context", "<x-site-context>")
    req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Possible Responses

200 OK

{
  "success": [\
    {\
      "sku": "sku1",\
      "itemId": "611686da50fb7e0c5df78c2e",\
      "itemIdSeq": 12,\
      "message": "SKU created successfully.",\
      "errorAttributes": [\
        {\
          "name": "Inactive",\
          "message": "Attribute value is invalid."\
        }\
      ],\
      "errorBundles": [\
        {\
          "name": "<string>",\
          "message": "<string>"\
        }\
      ]\
    }\
  ],\
  "failed": [\
    {\
      "sku": "sku1",\
      "message": "Failed because of validation"\
    }\
  ],\
  "itemIds": [\
    "611686da50fb7e0c5df78c2e",\
    "711686da50fb7e0c5df78c22"\
  ]
}

400 Client error

{
  "code": 400,
  "message": "Client error"
}

500 Internal Server Error

{
  "code": 500,
  "message": "An internal error occurred. If the issue persists please contact support@fabric.inc."
}